note
  description : "System's root class"
  author : "Gunnar Gotshalks"
  date : "2004 September 15"

-- Show that assertions can call user routines.
-- Show that assertions are not executed within routines called from assertions.
-- Comment out, in turn, each of the invariant assertions in the routine
-- test_loop. The invariant with '=' is correct.  The invariant with '/=' is
-- incorrect.  Note that with the incorrect invariant the call to
-- test_assertion succeeds, while the call at b1 fails.

class ROOT_CLASS
  create make
feature
  j, k : INTEGER
  b1 : BOOLEAN

make
  do
  io.put_string("Start of test%N")
  test_assertions  --  The routines calls the function text_loop.

  b1 := test_loop
  io.put_string("End of test%N")
end

test_loop : BOOLEAN
do
  from j := 1 ; k := 10
  invariant j + k = 11
--  invariant j + k /= 11
  until j > 10
  loop
    k := k - 1
    j := j + 1
  variant 10  - j + 1
  end
  Result := true
end

test_assertions
require test_loop
do
  print("Body of test_assertions%N")
end

end
